## freerdp 1.0.0

=== CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Client
# FreeRDP cmake build script
#
# Copyright 2011 O.S. Systems Software Ltda.
# Copyright 2011 Otavio Salvador <otavio@ossystems.com.br>
# Copyright 2011 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 2.6)
project(FreeRDP C)
set(CMAKE_COLOR_MAKEFILE ON)

# Include cmake modules
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(FindPkgConfig)
include(TestBigEndian)

# Include our extra modules
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/)

include(AutoVersioning)
include(ConfigOptions)
include(FindOptionalPackage)
include(CheckCCompilerFlag)
include(GNUInstallDirsWrapper)

# Soname versioning
set(FREERDP_VERSION_MAJOR "1")
set(FREERDP_VERSION_MINOR "0")
set(FREERDP_VERSION_REVISION "0")
set(FREERDP_VERSION "${FREERDP_VERSION_MAJOR}.${FREERDP_VERSION_MINOR}")
set(FREERDP_VERSION_FULL "${FREERDP_VERSION}.${FREERDP_VERSION_REVISION}")

# Default to release build type
if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE "Release")
endif()

# build shared libs
if(NOT BUILD_SHARED_LIBS)
    set(BUILD_SHARED_LIBS ON)
endif()

# Compiler-specific flags
if(CMAKE_COMPILER_IS_GNUCC)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
	CHECK_C_COMPILER_FLAG (-Wno-unused-result Wno-unused-result)
	if(Wno-unused-result)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-result")
	endif()
	CHECK_C_COMPILER_FLAG (-Wno-unused-but-set-variable Wno-unused-but-set-variable)
	if(Wno-unused-but-set-variable)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-but-set-variable")
	endif()
	if(CMAKE_BUILD_TYPE STREQUAL "Release")
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O2")
	endif()
	if(WITH_SSE2_TARGET)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -msse2")
	endif()
endif()

if(MSVC)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /Gd /MT")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /O2 /Ob2")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_X86_")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_UNICODE")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DFREERDP_EXPORTS")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_CRT_SECURE_NO_WARNINGS")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DWIN32_LEAN_AND_MEAN")
	SET(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR})
	SET(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR})
endif()

# Include files
check_include_files(sys/param.h HAVE_SYS_PARAM_H)
check_include_files(sys/socket.h HAVE_SYS_SOCKET_H)
check_include_files(netdb.h HAVE_NETDB_H)
check_include_files(fcntl.h HAVE_FCNTL_H)
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(limits.h HAVE_LIMITS_H)
check_include_files(stdint.h HAVE_STDINT_H)
check_include_files(stdbool.h HAVE_STDBOOL_H)
check_include_files(inttypes.h HAVE_INTTYPES_H)

# Libraries that we have a hard dependency on
find_required_package(OpenSSL)

# Mac OS X
if(APPLE)
	include_directories(/opt/local/include)
	link_directories(/opt/local/lib)
	set(CMAKE_SHARED_LINKER_FLAGS "-mmacosx-version-min=10.4")
endif()

if(NOT WIN32)
	find_required_package(ZLIB)
	find_optional_package(PulseAudio)
	find_optional_package(PCSC)
	find_suggested_package(Cups)
	find_suggested_package(FFmpeg)

	if(NOT APPLE)
		find_suggested_package(ALSA)
	endif()
endif()

# Endian
test_big_endian(BIG_ENDIAN)

# Path to put keymaps
set(FREERDP_KEYMAP_PATH "${CMAKE_INSTALL_PREFIX}/freerdp/keymaps")

# Path to put plugins
set(FREERDP_PLUGIN_PATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/freerdp")

# Include directories
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_SOURCE_DIR}/include)

# Configure files
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)

# Generate pkg-config
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/freerdp.pc.in ${CMAKE_CURRENT_BINARY_DIR}/freerdp.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/freerdp.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

# Build CUnit
find_optional_package(CUnit)
if(CUNIT_FOUND)
   enable_testing()
   add_subdirectory(cunit)
endif()

# Sub-directories
add_subdirectory(include)
add_subdirectory(libfreerdp-utils)

if(NOT WIN32)
	add_subdirectory(libfreerdp-kbd)
endif()

add_subdirectory(libfreerdp-gdi)
add_subdirectory(libfreerdp-rail)
add_subdirectory(libfreerdp-cache)
add_subdirectory(libfreerdp-codec)
add_subdirectory(libfreerdp-channels)
add_subdirectory(libfreerdp-core)

if(NOT WIN32)
	add_subdirectory(channels)
endif()

add_subdirectory(client)
add_subdirectory(server)
add_subdirectory(keymaps)

# Source package
set(CPACK_SOURCE_IGNORE_FILES "/\\\\.git/;/\\\\.gitignore;/CMakeCache.txt")

string(TOLOWER ${CMAKE_PROJECT_NAME} CMAKE_PROJECT_NAME_lower)
set(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME_lower}-${FREERDP_VERSION_FULL}")

include(CPack)

=== client/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Client
# FreeRDP Client User Interfaces
#
# Copyright 2011 O.S. Systems Software Ltda.
# Copyright 2011 Otavio Salvador <otavio@ossystems.com.br>
# Copyright 2011 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# User Interfaces

if(NOT WIN32)
	# Build Test Client
	add_subdirectory(test)

	# Build X11 Client
	find_suggested_package(X11)
	if(X11_FOUND)
		add_subdirectory(X11)
	endif()

	# Build DirectFB Client
	find_optional_package(DirectFB)
	if(DIRECTFB_FOUND)
		add_subdirectory(DirectFB)
	endif()
else()
	# Build Windows Client
	add_subdirectory(Windows)
endif()

=== libfreerdp-codec/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Client
# libfreerdp-codec cmake build script
#
# Copyright 2011 O.S. Systems Software Ltda.
# Copyright 2011 Otavio Salvador <otavio@ossystems.com.br>
# Copyright 2011 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(FREERDP_CODEC_SRCS
	bitmap.c
	color.c
	rfx_bitstream.h
	rfx_constants.h
	rfx_decode.c
	rfx_decode.h
	rfx_differential.c
	rfx_differential.h
	rfx_dwt.c
	rfx_dwt.h
	rfx_encode.c
	rfx_encode.h
	rfx_pool.c
	rfx_pool.h
	rfx_quantization.c
	rfx_quantization.h
	rfx_rlgr.c
	rfx_rlgr.h
	rfx_types.h
	rfx.c
	nsc.c
)

if(WITH_SSE2)
	set(FREERDP_CODEC_SRCS ${FREERDP_CODEC_SRCS}
	rfx_sse2.c
	rfx_sse2.h
)
	set_property(SOURCE rfx_sse2.c PROPERTY COMPILE_FLAGS "-msse2")
endif()

add_library(freerdp-codec ${FREERDP_CODEC_SRCS})

set_target_properties(freerdp-codec PROPERTIES VERSION ${FREERDP_VERSION_FULL} SOVERSION ${FREERDP_VERSION} PREFIX "lib")
target_link_libraries(freerdp-codec freerdp-utils)

install(TARGETS freerdp-codec DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== libfreerdp-kbd/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Client
# libfreerdp-kbd cmake build script
#
# Copyright 2011 O.S. Systems Software Ltda.
# Copyright 2011 Otavio Salvador <otavio@ossystems.com.br>
# Copyright 2011 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(FREERDP_KBD_SRCS
	locales.c
	layouts.c
	layouts_xkb.c
	layouts_xkb.h
	x_layout_id_table.c
	x_layout_id_table.h
	libkbd.c
	libkbd.h)

add_library(freerdp-kbd ${FREERDP_KBD_SRCS})

find_suggested_package(X11)
if(X11_FOUND)
	target_link_libraries(freerdp-kbd ${X11_LIBRARIES})
endif()

if(NOT APPLE)
	find_suggested_package(XKBFile)
	if(XKBFILE_FOUND)
		add_definitions(-DWITH_XKBFILE)
		include_directories(${XKBFILE_INCLUDE_DIRS})
		target_link_libraries(freerdp-kbd ${XKBFILE_LIBRARIES})
	endif()
endif()

add_definitions(-DKEYMAP_PATH="${FREERDP_KEYMAP_PATH}")

set_target_properties(freerdp-kbd PROPERTIES VERSION ${FREERDP_VERSION_FULL} SOVERSION ${FREERDP_VERSION} PREFIX "lib")

install(TARGETS freerdp-kbd DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== libfreerdp-utils/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Client
# libfreerdp-utils cmake build script
#
# Copyright 2011 O.S. Systems Software Ltda.
# Copyright 2011 Otavio Salvador <otavio@ossystems.com.br>
# Copyright 2011 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(CMAKE_THREAD_PREFER_PTHREAD)
find_required_package(Threads)

set(FREERDP_UTILS_SRCS
	args.c
	blob.c
	dsp.c
	event.c
	bitmap.c
	hexdump.c
	list.c
	file.c
	load_plugin.c
	memory.c
	mutex.c
	passphrase.c
	pcap.c
	profiler.c
	rail.c
	rect.c
	registry.c
	certstore.c
	semaphore.c
	signal.c
	sleep.c
	stopwatch.c
	stream.c
	string.c
	svc_plugin.c
	thread.c
	unicode.c
	wait_obj.c)

add_definitions(-DPLUGIN_PATH="${FREERDP_PLUGIN_PATH}")

add_library(freerdp-utils ${FREERDP_UTILS_SRCS})

set_target_properties(freerdp-utils PROPERTIES VERSION ${FREERDP_VERSION_FULL} SOVERSION ${FREERDP_VERSION} PREFIX "lib")

target_link_libraries(freerdp-utils ${CMAKE_THREAD_LIBS_INIT} ${CMAKE_DL_LIBS})

if(WIN32)
	target_link_libraries(freerdp-utils ws2_32)
endif()
if(${CMAKE_SYSTEM_NAME} MATCHES SunOS)
	target_link_libraries(freerdp-utils rt)
endif()

install(TARGETS freerdp-utils DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== server/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Client
# FreeRDP Servers
#
# Copyright 2011 O.S. Systems Software Ltda.
# Copyright 2011 Otavio Salvador <otavio@ossystems.com.br>
# Copyright 2011 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Servers

if(NOT WIN32)

	# Build Test Server
	add_subdirectory(test)

	# Build X11 Server
	find_suggested_package(X11)
	if(X11_FOUND)
		add_subdirectory(X11)
	endif()
	
endif()

=== channels/rdpdr/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Client
# FreeRDP cmake build script
#
# Copyright 2011 O.S. Systems Software Ltda.
# Copyright 2011 Otavio Salvador <otavio@ossystems.com.br>
# Copyright 2011 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(RDPDR_SRCS
	rdpdr_constants.h
	rdpdr_types.h
	rdpdr_capabilities.c
	rdpdr_capabilities.h
	devman.c
	devman.h
	irp.c
	irp.h
	rdpdr_main.c
	rdpdr_main.h
)

add_library(rdpdr ${RDPDR_SRCS})
set_target_properties(rdpdr PROPERTIES PREFIX "")

target_link_libraries(rdpdr freerdp-utils)

install(TARGETS rdpdr DESTINATION ${FREERDP_PLUGIN_PATH})

add_subdirectory(disk)
add_subdirectory(printer)
add_subdirectory(parallel)
add_subdirectory(serial)

if(PCSC_FOUND)
	add_subdirectory(smartcard)
endif()

=== channels/rdpsnd/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Client
# FreeRDP cmake build script
#
# Copyright 2011 O.S. Systems Software Ltda.
# Copyright 2011 Otavio Salvador <otavio@ossystems.com.br>
# Copyright 2011 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(RDPSND_SRCS
	rdpsnd_main.c
	rdpsnd_main.h
)

add_library(rdpsnd ${RDPSND_SRCS})
set_target_properties(rdpsnd PROPERTIES PREFIX "")

target_link_libraries(rdpsnd freerdp-utils)

install(TARGETS rdpsnd DESTINATION ${FREERDP_PLUGIN_PATH})

if(ALSA_FOUND)
	add_subdirectory(alsa)
endif()

if(PULSE_FOUND)
	add_subdirectory(pulse)
endif()

=== client/X11/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Client
# FreeRDP X11 Client
#
# Copyright 2011 O.S. Systems Software Ltda.
# Copyright 2011 Otavio Salvador <otavio@ossystems.com.br>
# Copyright 2011 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

include(FindXmlto)
include_directories(${X11_INCLUDE_DIRS})

add_executable(xfreerdp
	xf_gdi.c
	xf_gdi.h
	xf_rail.c
	xf_rail.h
	xf_tsmf.c
	xf_tsmf.h
	xf_event.c
	xf_event.h
	xf_cliprdr.c
	xf_cliprdr.h
	xf_monitor.c
	xf_monitor.h
	xf_graphics.c
	xf_graphics.h
	xf_keyboard.c
	xf_keyboard.h
	xf_window.c
	xf_window.h
	xfreerdp.c
	xfreerdp.h)

if(WITH_MANPAGES)
	if(XMLTO_FOUND)
		add_custom_command(OUTPUT xfreerdp.1
			COMMAND ${XMLTO_EXECUTABLE} man ${CMAKE_CURRENT_SOURCE_DIR}/xfreerdp.1.xml
			DEPENDS xfreerdp.1.xml)

		add_custom_target(xfreerdp.manpage ALL
			DEPENDS xfreerdp.1)

		install(FILES ${CMAKE_CURRENT_BINARY_DIR}/xfreerdp.1 DESTINATION share/man/man1)
	else(XMLTO_FOUND)
		message(WARNING "WITH_MANPAGES was set, but xmlto was not found. man-pages will not be installed")
	endif(XMLTO_FOUND)
endif(WITH_MANPAGES)

find_suggested_package(Xinerama)
if(XINERAMA_FOUND)
	add_definitions(-DWITH_XINERAMA -DWITH_XEXT)
	include_directories(${XINERAMA_INCLUDE_DIRS})
	target_link_libraries(xfreerdp ${XINERAMA_LIBRARIES})
endif()

find_suggested_package(Xext)
if(XEXT_FOUND)
	add_definitions(-DWITH_XEXT)
	include_directories(${XEXT_INCLUDE_DIRS})
	target_link_libraries(xfreerdp ${XEXT_LIBRARIES})
endif()

find_suggested_package(Xcursor)
if(XCURSOR_FOUND)
	add_definitions(-DWITH_XCURSOR)
	include_directories(${XCURSOR_INCLUDE_DIRS})
	target_link_libraries(xfreerdp ${XCURSOR_LIBRARIES})
endif()

find_suggested_package(Xv)
if(XV_FOUND)
	add_definitions(-DWITH_XV)
	include_directories(${XV_INCLUDE_DIRS})
	target_link_libraries(xfreerdp ${XV_LIBRARIES})
endif()

include_directories(${CMAKE_SOURCE_DIR}/resources)

target_link_libraries(xfreerdp freerdp-core)
target_link_libraries(xfreerdp freerdp-gdi)
target_link_libraries(xfreerdp freerdp-kbd)
target_link_libraries(xfreerdp freerdp-rail)
target_link_libraries(xfreerdp freerdp-channels)
target_link_libraries(xfreerdp freerdp-utils)
target_link_libraries(xfreerdp ${X11_LIBRARIES} ${CMAKE_DL_LIBS})

install(TARGETS xfreerdp DESTINATION ${CMAKE_INSTALL_BINDIR})

=== server/X11/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Client
# FreeRDP X11 Server cmake build script
#
# Copyright 2011 O.S. Systems Software Ltda.
# Copyright 2011 Otavio Salvador <otavio@ossystems.com.br>
# Copyright 2011 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

include_directories(${X11_INCLUDE_DIRS})

add_executable(xfreerdp-server
	xf_peer.c
	xf_encode.c
	xfreerdp.c)

find_suggested_package(XShm)
if(XSHM_FOUND)
	add_definitions(-DWITH_XSHM)
	include_directories(${XSHM_INCLUDE_DIRS})
endif()

find_suggested_package(Xext)
if(XEXT_FOUND)
	add_definitions(-DWITH_XEXT)
	include_directories(${XEXT_INCLUDE_DIRS})
	target_link_libraries(xfreerdp-server ${XEXT_LIBRARIES})
endif()

find_suggested_package(Xdamage)
if(XDAMAGE_FOUND)
        add_definitions(-DWITH_XDAMAGE)
        include_directories(${XDAMAGE_INCLUDE_DIRS})
        target_link_libraries(xfreerdp-server ${XDAMAGE_LIBRARIES})
endif()

find_suggested_package(Xfixes)
if(XFIXES_FOUND)
        add_definitions(-DWITH_XFIXES)
        include_directories(${XFIXES_INCLUDE_DIRS})
        target_link_libraries(xfreerdp-server ${XFIXES_LIBRARIES})
endif()

find_suggested_package(XTest)
if(XTEST_FOUND)
        add_definitions(-DWITH_XTEST)
        include_directories(${XTEST_INCLUDE_DIRS})
        target_link_libraries(xfreerdp-server ${XTEST_LIBRARIES})
endif()

target_link_libraries(xfreerdp-server freerdp-core)
target_link_libraries(xfreerdp-server freerdp-codec)
target_link_libraries(xfreerdp-server freerdp-utils)
target_link_libraries(xfreerdp-server freerdp-gdi)
target_link_libraries(xfreerdp-server freerdp-kbd)
target_link_libraries(xfreerdp-server ${X11_LIBRARIES})

=== channels/drdynvc/audin/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Client
# FreeRDP cmake build script
#
# Copyright 2011 O.S. Systems Software Ltda.
# Copyright 2011 Otavio Salvador <otavio@ossystems.com.br>
# Copyright 2011 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(AUDIN_SRCS
	audin_main.c
	audin_main.h
)

include_directories(..)

add_library(audin ${AUDIN_SRCS})
set_target_properties(audin PROPERTIES PREFIX "")

target_link_libraries(audin freerdp-utils)

install(TARGETS audin DESTINATION ${FREERDP_PLUGIN_PATH})

if(ALSA_FOUND)
	add_subdirectory(alsa)
endif()

if(PULSE_FOUND)
	add_subdirectory(pulse)
endif()

=== channels/drdynvc/tsmf/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Client
# FreeRDP cmake build script
#
# Copyright 2011 O.S. Systems Software Ltda.
# Copyright 2011 Otavio Salvador <otavio@ossystems.com.br>
# Copyright 2011 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(TSMF_SRCS
	tsmf_audio.c
	tsmf_audio.h
	tsmf_codec.c
	tsmf_codec.h
	tsmf_constants.h
	tsmf_decoder.c
	tsmf_decoder.h
	tsmf_ifman.c
	tsmf_ifman.h
	tsmf_main.c
	tsmf_main.h
	tsmf_media.c
	tsmf_media.h
	tsmf_types.h
)

include_directories(..)

add_library(tsmf ${TSMF_SRCS})
set_target_properties(tsmf PROPERTIES PREFIX "")

target_link_libraries(tsmf freerdp-utils)

install(TARGETS tsmf DESTINATION ${FREERDP_PLUGIN_PATH})

if(FFMPEG_FOUND)
	add_subdirectory(ffmpeg)
endif()

if(ALSA_FOUND)
	add_subdirectory(alsa)
endif()

if(PULSE_FOUND)
	add_subdirectory(pulse)
endif()

=== debian/changelog ===
freerdp (1.0.0-1) unstable; urgency=low

  [ Jeremy Bicha ]
  * New upstream release. Closes: #647498.
  * Updated symbols and bumped soname
  * debian/control:
    - Added new build dependencies
    - Bump Standards-Version to 3.9.2
  * debian/source/format: Set to 3.0 (quilt)
  * debian/rules: Turn on strict symbols checking
  * debian/watch: Watch github

  [ Jean-Louis Dupond ]
  * debian/control: Updated homepage
  * debian/copyright: Reflect upstream switch to the Apache license

  [ Martin Pitt ]
  * debian/libfreerdp0.symbols: Fix version number, should
    be 1.0~beta5, not 1.0-beta5.
  * debian/control: Add libavcodec-dev build dependency, upstream build system
    checks for that. Thanks Jean-Louis Dupond!

 -- Otavio Salvador <otavio@debian.org>  Tue, 31 Jan 2012 11:46:23 -0200

freerdp (0.8.2-2) unstable; urgency=low

  * freerdp-x11: recommends libfreerdp-plugins-standard. Closes:
    #603462.

 -- Otavio Salvador <otavio@debian.org>  Fri, 19 Nov 2010 19:27:45 -0200

freerdp (0.8.2-1) unstable; urgency=low

  * New upstream version.

 -- Otavio Salvador <otavio@debian.org>  Sat, 13 Nov 2010 10:58:11 -0200

freerdp (0.8.1-2) unstable; urgency=low

  * Add symbols file to allow for correct depends. Closes: #602218.

 -- Otavio Salvador <otavio@debian.org>  Wed, 03 Nov 2010 09:46:00 -0200

freerdp (0.8.1-1) unstable; urgency=low

  * New upstream release.

 -- Otavio Salvador <otavio@debian.org>  Mon, 25 Oct 2010 14:29:02 -0200

freerdp (0.7.4-1) unstable; urgency=low

  * New upstream release.
    - Fixes connection with VirtualBox RDP server. Closes: #592454.
  * Bump standards-version; no changes needed.

 -- Otavio Salvador <otavio@debian.org>  Thu, 26 Aug 2010 11:07:49 -0300

freerdp (0.7.3-1) unstable; urgency=low

  * New upstream release.
  * Fix section of libfreerdp0 to follow overrides.
  * Add a watch file so it is easier to track new releases.

 -- Otavio Salvador <otavio@debian.org>  Tue, 27 Jul 2010 01:13:00 -0300

freerdp (0.7.2-1) unstable; urgency=low

  * New upstream release.

 -- Otavio Salvador <otavio@debian.org>  Mon, 05 Jul 2010 14:05:26 -0300

freerdp (0.7.1-1) unstable; urgency=low

  * New upstream release.
  * debian/copyright: add missing entries.

 -- Otavio Salvador <otavio@debian.org>  Wed, 23 Jun 2010 21:39:09 -0300

freerdp (0.7.0+debian-1) unstable; urgency=low

  * Initial release.
  * Rebuild upstream tarball without debian directory.

 -- Otavio Salvador <otavio@debian.org>  Fri, 18 Jun 2010 15:09:19 -0300

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh ${@}

override_dh_install:
	# Removing unused files
	rm -f debian/tmp/usr/lib/*.la
	rm -f debian/tmp/usr/lib/freerdp/*.la

	dh_install --fail-missing

override_dh_strip:
	dh_strip --dbg-package=freerdp-dbg

override_dh_makeshlibs:
	dh_makeshlibs -V -- -c4

## freerdp 1.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -39,7 +39,7 @@
 # Soname versioning
 set(FREERDP_VERSION_MAJOR "1")
 set(FREERDP_VERSION_MINOR "0")
-set(FREERDP_VERSION_REVISION "0")
+set(FREERDP_VERSION_REVISION "1")
 set(FREERDP_VERSION "${FREERDP_VERSION_MAJOR}.${FREERDP_VERSION_MINOR}")
 set(FREERDP_VERSION_FULL "${FREERDP_VERSION}.${FREERDP_VERSION_REVISION}")
 
@@ -65,6 +65,7 @@
 		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-but-set-variable")
 	endif()
 	if(CMAKE_BUILD_TYPE STREQUAL "Release")
+		set(CMAKE_C_FLAGS_RELEASE "-DNDEBUG")
 		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O2")
 	endif()
 	if(WITH_SSE2_TARGET)
@@ -110,10 +111,12 @@
 	find_optional_package(PulseAudio)
 	find_optional_package(PCSC)
 	find_suggested_package(Cups)
-	find_suggested_package(FFmpeg)
 
 	if(NOT APPLE)
+		find_suggested_package(FFmpeg)
 		find_suggested_package(ALSA)
+	else(NOT APPLE)
+		find_optional_package(FFmpeg)
 	endif()
 endif()
 
@@ -139,7 +142,7 @@
 
 # Build CUnit
 find_optional_package(CUnit)
-if(CUNIT_FOUND)
+if(WITH_CUNIT)
    enable_testing()
    add_subdirectory(cunit)
 endif()
@@ -163,8 +166,16 @@
 	add_subdirectory(channels)
 endif()
 
-add_subdirectory(client)
-add_subdirectory(server)
+option(WITH_CLIENT "Build client binaries" ON)
+if(WITH_CLIENT)
+	add_subdirectory(client)
+endif()
+
+option(WITH_SERVER "Build server binaries" OFF)
+if(WITH_SERVER)
+	add_subdirectory(server)
+endif()
+
 add_subdirectory(keymaps)
 
 # Source package

=== libfreerdp-rail/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Client
# libfreerdp-rail cmake build script
#
# Copyright 2011 O.S. Systems Software Ltda.
# Copyright 2011 Otavio Salvador <otavio@ossystems.com.br>
# Copyright 2011 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(FREERDP_RAIL_SRCS
	window_list.c
	window.c
	icon.c
	rail.c
	librail.h)

add_library(freerdp-rail ${FREERDP_RAIL_SRCS})

set_target_properties(freerdp-rail PROPERTIES VERSION ${FREERDP_VERSION_FULL} SOVERSION ${FREERDP_VERSION} PREFIX "lib")

target_link_libraries(freerdp-rail freerdp-utils)

install(TARGETS freerdp-rail DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== channels/rdpdr/serial/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Client
# FreeRDP cmake build script
#
# Copyright 2011 O.S. Systems Software Ltda.
# Copyright 2011 Otavio Salvador <otavio@ossystems.com.br>
# Copyright 2011 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(serial_SRCS
	serial_tty.c
	serial_tty.h
	serial_constants.h
	serial_main.c
)

include_directories(..)

add_library(serial ${serial_SRCS})
set_target_properties(serial PROPERTIES PREFIX "")

target_link_libraries(serial freerdp-utils)

install(TARGETS serial DESTINATION ${FREERDP_PLUGIN_PATH})

=== channels/rdpdr/smartcard/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Client
# FreeRDP cmake build script
#
# Copyright 2011 O.S. Systems Software Ltda.
# Copyright 2011 Otavio Salvador <otavio@ossystems.com.br>
# Copyright 2011 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(SCARD_SRCS
	scard_main.c
	scard_operations.c
)

include_directories(..)
include_directories(${PCSC_INCLUDE_DIRS})

add_library(scard ${SCARD_SRCS})
set_target_properties(scard PROPERTIES PREFIX "")

target_link_libraries(scard freerdp-utils)
target_link_libraries(scard ${PCSC_LIBRARIES})

install(TARGETS scard DESTINATION ${FREERDP_PLUGIN_PATH})

=== channels/rdpsnd/pulse/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Client
# FreeRDP cmake build script
#
# Copyright 2011 O.S. Systems Software Ltda.
# Copyright 2011 Otavio Salvador <otavio@ossystems.com.br>
# Copyright 2011 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(RDPSND_PULSE_SRCS
	rdpsnd_pulse.c
)

include_directories(..)
include_directories(${PULSE_INCLUDE_DIRS})

add_library(rdpsnd_pulse ${RDPSND_PULSE_SRCS})
set_target_properties(rdpsnd_pulse PROPERTIES PREFIX "")

target_link_libraries(rdpsnd_pulse freerdp-utils)
target_link_libraries(rdpsnd_pulse ${PULSE_LIBRARIES})

install(TARGETS rdpsnd_pulse DESTINATION ${FREERDP_PLUGIN_PATH})

=== channels/drdynvc/audin/pulse/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Client
# FreeRDP cmake build script
#
# Copyright 2011 O.S. Systems Software Ltda.
# Copyright 2011 Otavio Salvador <otavio@ossystems.com.br>
# Copyright 2011 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(AUDIN_PULSE_SRCS
	audin_pulse.c
)

include_directories(..)
include_directories(${PULSE_INCLUDE_DIRS})

add_library(audin_pulse ${AUDIN_PULSE_SRCS})
set_target_properties(audin_pulse PROPERTIES PREFIX "")

target_link_libraries(audin_pulse freerdp-utils)
target_link_libraries(audin_pulse ${PULSE_LIBRARIES})

install(TARGETS audin_pulse DESTINATION ${FREERDP_PLUGIN_PATH})

=== channels/drdynvc/tsmf/pulse/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Client
# FreeRDP cmake build script
#
# Copyright 2011 O.S. Systems Software Ltda.
# Copyright 2011 Otavio Salvador <otavio@ossystems.com.br>
# Copyright 2011 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(TSMF_PULSE_SRCS
	tsmf_pulse.c
)

include_directories(..)
include_directories(${PULSE_INCLUDE_DIRS})

add_library(tsmf_pulse ${TSMF_PULSE_SRCS})
set_target_properties(tsmf_pulse PROPERTIES PREFIX "")

target_link_libraries(tsmf_pulse freerdp-utils)
target_link_libraries(tsmf_pulse ${PULSE_LIBRARIES})

install(TARGETS tsmf_pulse DESTINATION ${FREERDP_PLUGIN_PATH})

=== debian/changelog ===
freerdp (1.0.1-1ubuntu2.2) precise-proposed; urgency=low

  * Cherry pick upstream bugfix for crash when $HOME is unset.
    (LP: #1011790)

 -- Stéphane Graber <stgraber@ubuntu.com>  Sun, 11 Nov 2012 18:39:50 -0500

freerdp (1.0.1-1ubuntu2.1) precise-proposed; urgency=low

  * debian/patches/remote_control.diff: Cherry pick patch from upstream.
    This fixes crash in 'Remote Control'. (LP: #1000356)

 -- Jean-Louis Dupond <jean-louis@dupond.be>  Thu, 24 May 2012 13:52:13 +0200

freerdp (1.0.1-1ubuntu2) precise; urgency=low

  * debian/rules: Drop -Skde, autodetection will work fine.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 14 Feb 2012 14:34:18 +0100

freerdp (1.0.1-1ubuntu1) precise; urgency=low

  * debian/control, debian/rules: Drop libavcodec-dev build dependency and
    disable ffmpeg support, to avoid the banned libavcodec53 on the
    installation images. Support for MMR will come back later in the planned
    gstreamer rewrite. (LP: #931931)

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 14 Feb 2012 13:26:44 +0100

freerdp (1.0.1-1) unstable; urgency=low

  [ Jeremy Bicha ]
  * New upstream release. Closes: #659332.
  * Updated symbols

 -- Otavio Salvador <otavio@debian.org>  Sat, 11 Feb 2012 10:34:05 -0200

freerdp (1.0.0-2) unstable; urgency=low

  [ Jeremy Bicha ]
  * Don't install the freerdp keymaps; they're provided by xkb   

 -- Otavio Salvador <otavio@debian.org>  Tue, 31 Jan 2012 23:50:40 -0200

=== debian/control ===
Source: freerdp
Section: x11
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Otavio Salvador <otavio@debian.org>
Build-Depends:
 debhelper (>= 7.0.50~), autotools-dev, cmake, libasound2-dev, libcups2-dev,
 libpcsclite-dev, libpulse-dev, libssl-dev, libx11-dev, libxcursor-dev,
 libxdamage-dev, libxext-dev, libxkbfile-dev, libxinerama-dev, libxv-dev,
 pkg-config, xmlto
Standards-Version: 3.9.2
Homepage: http://www.freerdp.com/
Vcs-Browser: http://git.debian.org/?p=collab-maint/freerdp.git
Vcs-Git: git://git.debian.org/git/collab-maint/freerdp.git

Package: freerdp-dbg
Section: debug
Priority: extra
Architecture: any
Depends:
 ${misc:Depends}, freerdp-x11 (= ${binary:Version}),
 libfreerdp1 (= ${binary:Version}),
 libfreerdp-plugins-standard (= ${binary:Version}),
Description: RDP client for Windows Terminal Services (debug)
 FreeRDP is a client for Windows Terminal Services implementing the Remote
 Desktop Protocol (RDP).
 .
 This package contains the debug symbols.

Package: freerdp-x11
Section: x11
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: libfreerdp-plugins-standard
Provides: freerdp
Description: RDP client for Windows Terminal Services
 FreeRDP is a client for Windows Terminal Services implementing the Remote
 Desktop Protocol (RDP).
 .
 Currently, the following Windows Versions are supported:
 .
  * Windows NT Server
  * Windows 2000 Terminal Server
  * Windows XP
  * Windows 2003 Server
  * Windows Vista
  * Windows 2008 Server
  * Windows 7
 .
 This package contains the X11 based client.

Package: libfreerdp1
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: xfreerdp
Description: RDP client for Windows Terminal Services (library)
 FreeRDP is a client for Windows Terminal Services implementing the Remote
 Desktop Protocol (RDP).
 .
 This package contains the shared library.

Package: libfreerdp-plugins-standard
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: RDP client for Windows Terminal Services (plugins)
 FreeRDP is a client for Windows Terminal Services implementing the Remote
 Desktop Protocol (RDP).
 .
 This package contains the plugins available to the Channel Manager extending
 the RDP core functionality, such as sounds, clipboard synchronisation,
 disk/printer redirection, etc.

Package: libfreerdp-dev
Section: libdevel
Architecture: any
Depends:
 ${misc:Depends}, libfreerdp1 (= ${binary:Version}),
 libfreerdp-plugins-standard (= ${binary:Version})
Description: RDP client for Windows Terminal Services (development)
 FreeRDP is a client for Windows Terminal Services implementing the Remote
 Desktop Protocol (RDP).
 .
 This package contains the development files.

=== debian/rules ===
--- 
+++ 
@@ -3,10 +3,14 @@
 %:
 	dh ${@}
 
+override_dh_auto_configure:
+	dh_auto_configure -- -DWITH_FFMPEG=OFF
+
 override_dh_install:
 	# Removing unused files
 	rm -f debian/tmp/usr/lib/*.la
 	rm -f debian/tmp/usr/lib/freerdp/*.la
+	rm -rf debian/tmp/usr/share/freerdp/keymaps
 
 	dh_install --fail-missing

=== debian/watch ===
version=3

http://sf.net/freerdp/freerdp-(.+)\.tar\.gz
